function cam = camobj(pos,target);

cam.pos = pos;
cam.target = target;
cam.up = [0 0 1];
cam.va = 40;

% camera transformation
vn = cam.target - cam.pos;
vz = vn/norm(vn);
vx = cross(vz,cam.up);
vx = vx/norm(vx);
vy = cross(vz,vx);
Rc = [vx; vy; vz];
cam.T = [Rc -Rc*cam.pos'];

% image transformation
NPIX = 640;
d = 0.5/tan(cam.va*pi/360);
f = d*NPIX;

cc = [NPIX; NPIX]/2;
cam.KK = [[f 0;0 f] cc; 0 0 1];


